import { Component, Inject, Injector } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { Data } from "./interface";
import { Router, ActivatedRoute } from "@angular/router";
import { CacheTokenService } from "./http-interceptors/cache-token.service"; //引入服务
import { MaskLayerService } from "./mask-layer.service";
import * as global from "globals";

@Component({
  selector: "app-root",
  templateUrl: "./app.component.html",
  styleUrls: ["./app.component.scss"],
})
export class AppComponent {
  constructor(
    private maskLayerService: MaskLayerService,
    private http: HttpClient,
    private router: Router,
    public token: CacheTokenService,
    private injector: Injector
  ) {
    global.injector = injector;
  }

  isMaskLayerShow: boolean = false;

  ngOnInit(): void {
    //监听遮罩层
    this.maskLayerService.getMessage().subscribe((message: any) => {
      this.isMaskLayerShow = message;
    });
    // console.log(1234,document.documentElement.clientWidth)
    function addMeta(name, content) {
      //手动添加mate标签

      let meta = document.createElement("meta");

      meta.content = content;

      meta.name = name;

      document.getElementsByTagName("head")[0].appendChild(meta);
    }
    if (document.documentElement.clientWidth < 800) {
      addMeta(
        "viewport",
        "initial-scale=0.5, maximum-scale=0.5, minimum-scale=0.5, user-scalable=no,uc-fitscreen=yes,viewport-fit=cover"
      );
    }

    if (sessionStorage.getItem("token") && !this.token.timer) {
      //调用服务中的function刷新token
      this.token.startUp();
    }
  }
}
