import { HttpClient } from '@angular/common/http';
import { Component, OnInit } from '@angular/core';

@Component({
  selector: 'app-export-excel',
  templateUrl: './export-excel.component.html',
  styleUrls: ['./export-excel.component.scss']
})
export class ExportExcelComponent implements OnInit {

  constructor(public http:HttpClient) { }

  ngOnInit(): void {
  }
  export(){
    const httpOptions = {
      responseType: 'blob' as 'json'
    };
    this.http.get('/api/StatisticsAnalysis/ExportToExcel',httpOptions).subscribe((data:any) => {
      // 文件名中有中文 则对文件名进行转码
      const link = document.createElement('a');
      const blob = new Blob([data], {type: 'application/vnd.ms-excel'});
      link.setAttribute('href', window.URL.createObjectURL(blob));
      link.setAttribute('download', '统计信息'+'.xls');
      link.style.visibility = 'hidden';
      document.body.appendChild(link);
      link.click();
      document.body.removeChild(link);
    })
  }
}
