import { HttpClient} from '@angular/common/http';
import { Component, Inject, OnInit, Renderer2, ViewChild,Input } from '@angular/core';
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { MatSnackBar } from '@angular/material/snack-bar';

@Component({
  selector: 'app-plan-list',
  templateUrl: './plan-list.component.html',
  styleUrls: ['./plan-list.component.scss']
})
export class PlanListComponent implements OnInit {
  constructor(private http: HttpClient,public snackBar: MatSnackBar,public dialog: MatDialog) { }
  @Input() public planType: any;//data名字根据引用场景自定义
  //单位相关数据
  unitId:any =  sessionStorage.getItem('unitId')

  ngOnInit(): void {
    this.getAllBuildings()
    this.getSitePlan()
  }

  //获得所有的建筑物
  allBuildings:any
  getAllBuildings(){
    this.http.get("/api/Buildings",{
      params:{
        companyId : this.unitId
      }
    }).subscribe((data:any)=>{
      data.forEach((item,index) => {
        let params = { buildingId: item.id }
        item.plandata = []
        this.http.get('/api/BuildingAreas',{params}).subscribe(data=>{
          item.plandata = data
        })
      })
      this.allBuildings = data
    })
  }
  //获取总平面图
  sitePlanItems:any
  getSitePlan () {
    let params = {companyId: this.unitId}
    this.http.get('/api/SitePlans',{params:params}).subscribe(data=>{
      this.sitePlanItems = data
    })
  }
  //打开采集工具
  openPlan(item,index){
    sessionStorage.setItem("gisplan",'look')
    sessionStorage.setItem("companyId",this.unitId)
    let data = {select: item, key: index, allBuildings: this.allBuildings}
    let width = Math.round(document.body.clientWidth * 0.8) + 'px'
    let height = Math.round(document.body.clientHeight * 0.9) + 'px'
    // console.log('宽度',width)
    let dialogRef = this.dialog.open(OpenPlanToolDialog,{//调用open方法打开对话框并且携带参数过去
      id:'openPlanToolDialog',
      data,
      width:width,
      height:height
    });
    dialogRef.afterClosed().subscribe( (data)=>{  } );
  }
}



//查看预案
@Component({
  selector: 'lookPlan-dialog',
  templateUrl: './openPlanTool.html',
  styleUrls: ['./openPlanTool.scss']
})
export class OpenPlanToolDialog {

  constructor(public http: HttpClient,public snackBar: MatSnackBar,public dialogRef: MatDialogRef<OpenPlanToolDialog>,
    @Inject(MAT_DIALOG_DATA) public data,private render2: Renderer2,public dialog: MatDialog) {}

  @ViewChild( 'plan',{static: false} ) plan:any //子组件
  
  ngOnInit() {
  }
  
  ngAfterViewInit(): void {
    this.noticePlan()
  }

  //通知 子组件 传递参数
  noticePlan () {
    let parameter = { //查询 节点 对应 建筑/楼层 index,id
      buildingIndex: this.data.key, //总平面图/建筑 index
      storeyId: this.data.select.id
    }
    this.http.get("/api/Buildings",{params:{companyId : sessionStorage.getItem('unitId')} }).subscribe((data:any)=>{
      this.plan.allBuildings = data
      this.plan.seekPanelPoint(parameter)
    })
  }
  
  //关闭弹窗
  closeDiv(){
    this.dialogRef.close()
  }

}