import { Injectable } from "@angular/core";
import { HttpClient } from "@angular/common/http";

@Injectable({
  providedIn: "root",
})
export class CacheTokenService {
  constructor(private http: HttpClient) {}
  public timer;

  //刷新token令牌定时器
  startUp = (): void => {
    window.clearInterval(this.timer); //清一遍定时器
    this.timer = window.setInterval(() => {
      var token = sessionStorage.getItem("token");
      var refreshToken = sessionStorage.getItem("refreshToken");
      this.http
        .post("/api/Account/RefreshToken", {
          token: token,
          refreshToken: refreshToken,
        })
        .subscribe((data: any) => {
          sessionStorage.setItem("level", data.level);
          sessionStorage.setItem("token", data.token);
          sessionStorage.setItem("refreshToken", data.refreshToken);
        });
    }, 5 * 60 * 1000);
  };

  //删除定时器
  delete = (): void => {
    window.clearInterval(this.timer);
  };
}
