import { NgModule } from "@angular/core";
import { CommonModule } from "@angular/common";
import { KeyUnitRoutingModule } from "./key-unit-routing.module";
import {
  KeyUnitManagementComponent,
  CreateUnit,
} from "./key-unit-management/key-unit-management.component";
import { A11yModule } from "@angular/cdk/a11y";
import { DragDropModule } from "@angular/cdk/drag-drop";
import { PortalModule } from "@angular/cdk/portal";
import { ScrollingModule } from "@angular/cdk/scrolling";
import { CdkStepperModule } from "@angular/cdk/stepper";
import { CdkTableModule } from "@angular/cdk/table";
import { CdkTreeModule } from "@angular/cdk/tree";
import { MatAutocompleteModule } from "@angular/material/autocomplete";
import { MatBadgeModule } from "@angular/material/badge";
import { MatBottomSheetModule } from "@angular/material/bottom-sheet";
import { MatButtonModule } from "@angular/material/button";
import { MatButtonToggleModule } from "@angular/material/button-toggle";
import { MatCardModule } from "@angular/material/card";
import { MatCheckboxModule } from "@angular/material/checkbox";
import { MatChipsModule } from "@angular/material/chips";
import { MatStepperModule } from "@angular/material/stepper";
import { MatDatepickerModule } from "@angular/material/datepicker";
import { MatDialogModule } from "@angular/material/dialog";
import { MatDividerModule } from "@angular/material/divider";
import { MatExpansionModule } from "@angular/material/expansion";
import { MatGridListModule } from "@angular/material/grid-list";
import { MatIconModule } from "@angular/material/icon";
import { MatInputModule } from "@angular/material/input";
import { MatListModule } from "@angular/material/list";
import { MatMenuModule } from "@angular/material/menu";
import {
  MatNativeDateModule,
  MatRippleModule,
  MatOption,
} from "@angular/material/core";
import { MatPaginatorModule } from "@angular/material/paginator";
import { MatProgressBarModule } from "@angular/material/progress-bar";
import { MatProgressSpinnerModule } from "@angular/material/progress-spinner";
import { MatRadioModule } from "@angular/material/radio";
import { MatSelectModule } from "@angular/material/select";
import { MatSidenavModule } from "@angular/material/sidenav";
import { MatSliderModule } from "@angular/material/slider";
import { MatSlideToggleModule } from "@angular/material/slide-toggle";
import { MatSnackBarModule } from "@angular/material/snack-bar";
import { MatSortModule } from "@angular/material/sort";
import { MatTableModule } from "@angular/material/table";
import { MatTabsModule } from "@angular/material/tabs";
import { MatToolbarModule } from "@angular/material/toolbar";
import { MatTooltipModule } from "@angular/material/tooltip";
import { MatTreeModule } from "@angular/material/tree";
import { EditUnitInfoComponent } from "./edit-unit-info/edit-unit-info.component";
import { ViewUnitDetailsComponent } from "./view-unit-details/view-unit-details.component";
import { ReactiveFormsModule, FormsModule } from "@angular/forms";
import { AddHouseInfo } from "./basicinfo/addhouseinfo.component";
import { LookMaster } from "./basicinfo/lookmaster.component";
import {
  BasicinfoComponent,
  StatisticsOfFireFightingFacilities,
} from "./basicinfo/basicinfo.component";
import { EditPlanInfoComponent } from "./edit-plan-info/edit-plan-info.component";
import { CountdownModule } from "ngx-countdown";
import { BasicinfoLookComponent } from "./basicinfo-look/basicinfo.component";
import { ViewUnitDetailsPlanComponent } from "./view-unit-details-plan/view-unit-details-plan.component";
import {
  FunctionDivisionComponent,
  addPartition,
  addPartitionAttribute,
} from "./function-division/function-division.component";
import { AllaroundComponent } from "./allaround/allaround.component";
import { ImgDetails } from "./allaround/imgdetails.component";
import {
  RealisticPictureComponent,
  previewImg,
  addRealPicture,
  editRealPicture,
} from "./realistic-picture/realistic-picture.component";
import { FileUploadModule } from "ng2-file-upload";
import { KeySiteComponent } from "./key-site/key-site.component";
import { KeySiteImgs } from "./key-site/keysiteimgs.component";
import {
  UploadingCADComponent,
  readFile,
  editFile,
} from "./uploading-cad/uploading-cad.component";
import { KeySiteLookComponent } from "./key-site-look/key-site.component";
import { KeySiteImgs2 } from "./key-site-look/keysiteimgs.component";
import {
  FunctionDivisionLookComponent,
  addPartitionAttribute2,
} from "./function-division-look/function-division.component";
import {
  RealisticPictureLookComponent,
  previewImg3,
} from "./realistic-picture-look/realistic-picture.component";
import { UploadingCADLookComponent } from "./uploading-cad-look/uploading-cad.component";
import { FireFightingDeviceComponent } from "./fire-fighting-device/fire-fighting-device.component";
import {
  ImagesData,
  previewBigImg,
} from "./fire-fighting-device/imagesdata.component";
import { ImgsDataDetail } from "./fire-fighting-device/addGrouping.component";
import { FireFightingDeviceLookComponent } from "./fire-fighting-device-look/fire-fighting-device.component";
import {
  ImagesData2,
  previewBigImg2,
} from "./fire-fighting-device-look/imagesdata.component";
import { ImgsDataDetail2 } from "./fire-fighting-device-look/addGrouping.component";
import { UiModule } from "../../app/ui/ui.module";
import {
  SixFamiliarityComponent,
  routerMapComponent,
} from "./six-familiarity/six-familiarity.component";
import { ActualCombatDrillComponent } from "./actual-combat-drill/actual-combat-drill.component";
import { SixFamiliarListComponent } from "./six-familiar-list/six-familiar-list.component";
import { TrainingRecordinfoComponent } from "./training-recordinfo/training-recordinfo.component";
import { RouterGISComponent } from "./router-gis/router-gis.component";
import { WaterRoadComponent } from "./water-road/water-road.component";
import { PhotoofthesceneComponent } from "./photoofthescene/photoofthescene.component";
import { KnowRouteComponent } from "./know-route/know-route.component";
import { FindProblemComponent } from "./find-problem/find-problem.component";
import { upname } from "./key-unit-management/key-unit-management.component";
import { companyAuditResult } from "./key-unit-management/key-unit-management.component";
import { SpecialWarningComponent } from "./special-warning/special-warning.component";
import { UploadDrillComponent } from "./key-unit-management/upload-drill/upload-drill.component";
import { NzDatePickerModule } from "ng-zorro-antd/date-picker";
import { NzInputModule } from "ng-zorro-antd/input";
import { NzButtonModule } from "ng-zorro-antd/button";

@NgModule({
  declarations: [
    KeyUnitManagementComponent,
    EditUnitInfoComponent,
    ViewUnitDetailsComponent,
    CreateUnit,
    BasicinfoComponent,
    LookMaster,
    AddHouseInfo,
    EditPlanInfoComponent,
    BasicinfoLookComponent,
    ViewUnitDetailsPlanComponent,
    FunctionDivisionComponent,
    addPartition,
    addPartitionAttribute,
    AllaroundComponent,
    ImgDetails,
    RealisticPictureComponent,
    previewImg,
    addRealPicture,
    editRealPicture,
    KeySiteComponent,
    KeySiteImgs,
    UploadingCADComponent,
    readFile,
    editFile,
    KeySiteLookComponent,
    KeySiteImgs2,
    FunctionDivisionLookComponent,
    RealisticPictureLookComponent,
    previewImg3,
    UploadingCADLookComponent,
    FireFightingDeviceComponent,
    ImagesData,
    previewBigImg,
    ImgsDataDetail,
    FireFightingDeviceLookComponent,
    ImagesData2,
    ImgsDataDetail2,
    previewBigImg2,
    addPartitionAttribute2,
    SixFamiliarityComponent,
    ActualCombatDrillComponent,
    routerMapComponent,
    SixFamiliarListComponent,
    TrainingRecordinfoComponent,
    RouterGISComponent,
    WaterRoadComponent,
    PhotoofthesceneComponent,
    KnowRouteComponent,
    FindProblemComponent,
    upname,
    companyAuditResult,
    StatisticsOfFireFightingFacilities,
    SpecialWarningComponent,
    UploadDrillComponent,
  ],
  exports: [ViewUnitDetailsPlanComponent, WaterRoadComponent],
  imports: [
    CommonModule,
    KeyUnitRoutingModule,
    A11yModule,
    CdkStepperModule,
    CdkTableModule,
    CdkTreeModule,
    DragDropModule,
    MatAutocompleteModule,
    MatBadgeModule,
    MatBottomSheetModule,
    MatButtonModule,
    MatButtonToggleModule,
    MatCardModule,
    MatCheckboxModule,
    MatChipsModule,
    MatStepperModule,
    MatDatepickerModule,
    MatDialogModule,
    MatDividerModule,
    MatExpansionModule,
    MatGridListModule,
    MatIconModule,
    MatInputModule,
    MatListModule,
    MatMenuModule,
    MatNativeDateModule,
    MatPaginatorModule,
    MatProgressBarModule,
    MatProgressSpinnerModule,
    MatRadioModule,
    MatRippleModule,
    MatSelectModule,
    MatSidenavModule,
    MatSliderModule,
    MatSlideToggleModule,
    MatSnackBarModule,
    MatSortModule,
    MatTableModule,
    MatTabsModule,
    MatToolbarModule,
    MatTooltipModule,
    MatTreeModule,
    PortalModule,
    ScrollingModule,
    FormsModule,
    CountdownModule,
    FileUploadModule,
    UiModule,
    ReactiveFormsModule,
    NzDatePickerModule,
    NzInputModule,
    NzButtonModule,
  ],
})
export class KeyUnitModule {}
