import { Component, OnInit ,ViewChild, AfterViewInit,ElementRef,Renderer2  } from '@angular/core';
import { HttpClient } from '@angular/common/http'
import { Router,ActivatedRoute } from '@angular/router'
declare var echarts: any;
declare var AMap: any;

declare var AMapUI: any;

@Component({
  selector: 'app-home',
  templateUrl: './home.component.html',
  styleUrls: ['./home.component.scss']
})
export class HomeComponent implements OnInit {
  
  constructor(private http:HttpClient, private render2: Renderer2,public element: ElementRef,private router:Router,private route:ActivatedRoute) { }
    keyUnitNum:any = 1500
    dataNum:any 
    planNum:any

    //全队数据采集和预案编制数量统计
    chartQusj:any
    chartQusjData:any
    chartQusjOption:any = {    
      grid: {
        top: 50,
        left: 30,
        right: 20,
        bottom: 20,
      },
      // 标题
      title: {
        text: '全队数据采集和预案编制数量统计',
        top: -4,
        left:-2
      },
      //图例
      legend: {
        top: 0,
        right:-2,
        //   left:3,
        data: ['单位预案编制数量', '单位数据采集数量'],
      },
      //提示框
      tooltip: {
        trigger: 'axis',
      },
      // x轴
      xAxis: {
        type: 'category',
        data: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
        boundaryGap: false,
      },
      // y轴
      yAxis: {
        type: 'value',
        name:'个'
      },
      // 数据
      series: [
        {
          name: '单位预案编制数量',
          type: 'line',
          data: [],
          // showSymbol: true,
          // symbolSize:6,
          // smooth: false,
          // label: {
          //   show: true,
          // },
          areaStyle: {  
            color: {
              type: 'linear',
              x: 0,
              y: 0,
              x2: 0,
              y2: 1,
              colorStops: [{
              offset: 0,
              color: 'rgba(60,103,195,1)' // 0% 处的颜色
              }, {
              offset: 1,
              color: 'rgba(0,194,255,.2)' // 100% 处的颜色
              }],
              global: false // 缺省为 false
            }
          }
        },
        {
            name: '单位数据采集数量',
            type: 'line',
            data: [],
        },
      ],
    };
    chartQusjOption2 = {
      grid: {
      top: 50,
      left: 30,
      right: 20,
      bottom: 20,
      },
      // 标题
      title: {
      text: '全队数据采集和预案编制数量统计',
      top: -4,
      left:-2
      },
      //图例
      legend: {
      top: 0,
      right:-2,
      //   left:3,
      data: ['单位预案编制数量', '单位数据采集数量'],
      },
      //提示框
      tooltip: {
      trigger: 'axis',
      },
      // x轴
      xAxis: {
      type: 'category',
      data: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
      boundaryGap: false,
      },
      // y轴
      yAxis: {
      type: 'value',
      name:'个'
      },
      // 数据
      series: [
      {
          name: '单位预案编制数量',
          type: 'line',
          data: [66, 25, 55, 56, 78, 15, 66, 69, 44, 78, 25, 66],
          // showSymbol: true,
          // symbolSize:6,
          // smooth: false,
          // label: {
          //   show: true,
          // },
          areaStyle: {
          color: {
              type: 'linear',
              x: 0,
              y: 0,
              x2: 0,
              y2: 1,
              colorStops: [{
              offset: 0,
              color: 'rgba(60,103,195,1)' // 0% 处的颜色
              }, {
              offset: 1,
              color: 'rgba(0,194,255,.2)' // 100% 处的颜色
              }],
              global: false // 缺省为 false
          }
          }
      },
      {
          name: '单位数据采集数量',
          type: 'line',
          data: [36, 48, 45, 36, 78, 16, 24, 56, 22, 25, 24, 77 ],
      },
      ],
    };



    //预案单位类型统计
    chartYadwlx:any
    unitTypeStatistics:any //存储各类型建筑预案数量初始数据
    data02:any = [];
    chartYadwlxOption:any = {
        // 标题
        title: {
        text: '预案单位类型统计',
        left: '15%',
        top:0
        },
        //图例
        legend: {
          orient: 'vertical',
          top: 'center',
          right: '0%',
          show: false,
          formatter: function (name) {
              var target;
              for (var i = 0, l = this.data02.length; i < l; i++) {
              if (this.data02[i].name == name) {
                  target = this.data02[i].value;
              }
              }
              return name + ' ' + target;
          }
        },
        //提示框
        tooltip: {
          trigger: 'item',
          formatter: '{b}:{c}份 <br/> 占比：{d}%'
        },
        // 数据
        series: [{
        type: 'pie',
        center: ['55%', '55%'],
        radius: ['25%', '60%'],
        roseType:true,
        // labelLine: {
        //   show: true,
        //   length: 20,
        //   length2: 0,
        //   lineStyle: {
        //     color: '#999',
        //     width: 1
        //   }
        // },
        labelLine:{
            lineStyle:{
            color: '#93FCFF'
            }
        },
        label: {
            //formatter: '{hr|}\n{a|{b}}\n{b|{c}}万吨\n{c|{d}%}',
            // formatter: '{a|{b}}\n{b|{c}}{c|份}\n{d|{d}%}',
            formatter: '{a|{b}} {b|{c}}{c|份}',
            rich: {
            // hr: {
            //   borderColor: '#999',
            //   width: '100%',
            //   borderWidth: 1,
            //   marginLeft: '-15px',
            //   marginRight: '-15px',
            //   height:0 
            // },
            a: {
                color: '#1F6F9B',
                fontSize: 12,
                height: 18,
                borderColor: '#999',
                //marginTop: '65px',
            },
            b: {
                color: '#fff',
                fontSize: 12,
                height: 36,
            },
            c: {
                color: '#fff',
                fontSize: 12,
            },
            d: {
                color: '#fff',
                fontSize: 12,
                height: 16,
                marginLeft: '5px',
            },
            },
        },
          data: [

          ],
        }],
    };
    data03:any = [
      {
      value: 56,
      name: '高层建筑'
      },
      {
        value: 88,
        name: '地下建筑'
      },
      {
        value: 38,
        name: '大型城市综合体'
      },
      {
        value: 45,
        name: '人员密集场所'
      },
      {
        value: 66,
        name: '石油化工类'
      },
      {
        value: 56,
        name: '地铁类'
      },
      {
        value: 88,
        name: '仓库、堆垛、厂房'
      },
      {
        value: 64,
        name: '隧道'
      },
      {
        value: 38,
        name: '其他'
      }
    ];
    chartYadwlxOption2:any = {
      // 标题
      title: {
        text: '预案单位类型统计',
        left: '15%',
        top:0
      },
      //图例
      legend: {
        orient: 'vertical',
        top: 'center',
        right: '0%',
        show: false,
        formatter: function (name) {
            var target;
            for (var i = 0, l = this.data03.length; i < l; i++) {
            if (this.data03[i].name == name) {
                target = this.data03[i].value;
            }
            }
            return name + ' ' + target;
        }
      },
      //提示框
      tooltip: {
      trigger: 'item',
      },
      // 数据
      series: [{
      type: 'pie',
      center: ['55%', '55%'],
      radius: ['25%', '60%'],
      roseType:true,
      // labelLine: {
      //   show: true,
      //   length: 20,
      //   length2: 0,
      //   lineStyle: {
      //     color: '#999',
      //     width: 1
      //   }
      // },
      labelLine:{
          lineStyle:{
          color: '#93FCFF'
          }
      },
      label: {
          //formatter: '{hr|}\n{a|{b}}\n{b|{c}}万吨\n{c|{d}%}',
          // formatter: '{a|{b}}\n{b|{c}}{c|份}\n{d|{d}%}',
          formatter: '{a|{b}} {b|{c}}{c|份}',
          rich: {
          // hr: {
          //   borderColor: '#999',
          //   width: '100%',
          //   borderWidth: 1,
          //   marginLeft: '-15px',
          //   marginRight: '-15px',
          //   height:0 
          // },
          a: {
              color: '#1F6F9B',
              fontSize: 12,
              height: 18,
              borderColor: '#999',
              //marginTop: '65px',
          },
          b: {
              color: '#fff',
              fontSize: 12,
              height: 36,
          },
          c: {
              color: '#fff',
              fontSize: 12,
          },
          d: {
              color: '#fff',
              fontSize: 12,
              height: 16,
              marginLeft: '5px',
          },
          },
      },
        data: [{
          value: 56,
          name: '高层建筑'
          },
          {
            value: 38,
            name: '大型城市综合体'
          },
          {
            value: 88,
            name: '地下建筑'
          },
          
          {
            value: 45,
            name: '人员密集场所'
          },
          {
            value: 66,
            name: '石油化工类'
          },
          {
            value: 56,
            name: '地铁类'
          },
          {
            value: 88,
            name: '仓库、堆垛、厂房'
          },
          {
            value: 64,
            name: '隧道'
          },
          {
            value: 38,
            name: '其他'
          }
        ],
      }],
    };





    // 预案评优排行
    chartYapyph:any
    chartYapyphOption:any = {
        // 标题
        title: {
          text: '预案评优排行',
          left:0
        },
        grid: {
          left: 80,
          right: 10,
        },
        //提示框
        tooltip: {
          trigger: 'axis',
        },
        // y轴
        yAxis: {
          type: 'category',
          data: ['防城港支队', '北海支队','梧州支队','桂林支队', '柳州支队','南宁支队']
        },
        // x轴
        xAxis: {
          type: 'value',
          splitLine: {
            show: true,
            lineStyle: {
              color: '#fff'
            }
          },
        },
        // 数据
        series: [{
            name: '预案评优',
            type: 'bar',
            data: [20, 26, 30, 32, 34, 38],
            label: {
              show: false,
              position: "top",
              formatter: '{c}',
              color: "#fff",
            },
            itemStyle: {
              color: {
                type: 'linear',
                x: 0,
                y: 0,
                x2: 0,
                y2: 1,
                colorStops: [{
                  offset: 0,
                  color: 'rgba(0,220,254,1)' // 0% 处的颜色
                }, {
                  offset: 1,
                  color: 'rgba(1,104,191,1)' // 100% 处的颜色
                }],
                globalCoord: false // 缺省为 false
              },
            }
          }
        ],
    };
    chartYapyphOption2:any = {
      // 标题
      title: {
        text: '预案评优排行',
        left:0
      },
      grid: {
        left: 80,
        right: 10,
      },
      //提示框
      tooltip: {
        trigger: 'axis',
      },
      // y轴
      yAxis: {
        type: 'category',
        data: []
      },
      // x轴
      xAxis: {
        type: 'value',
        splitLine: {
          show: true,
          lineStyle: {
            color: '#fff'
          }
        },
      },
      // 数据
      series: [{
          name: '预案评优',
          type: 'bar',
          data: [],
          label: {
            show: false,
            position: "top",
            formatter: '{c}',
            color: "#fff",
          },
          itemStyle: {
            color: {
              type: 'linear',
              x: 0,
              y: 0,
              x2: 0,
              y2: 1,
              colorStops: [{
                offset: 0,
                color: 'rgba(0,220,254,1)' // 0% 处的颜色
              }, {
                offset: 1,
                color: 'rgba(1,104,191,1)' // 100% 处的颜色
              }],
              globalCoord: false // 缺省为 false
            },
          }
        }
      ],
  };

    //预案类型统计
    chartYalxtj:any
    chartYalxtjOption:any = {
        color: ['#FB33C2', '#00CFF0', '#2C3DE0','#b9302d'],
        grid: {
          top: 50,
          left: 30,
          right: 20,
          bottom: 20,
        },
        // 标题
        title: {
          text: '预案类型统计',
          top: -4,
          left: 0
        },
        //图例
        legend: {
          top: 0,
          data: ['二维预案', '三维预案', '卡片预案', '其他预案'],
          icon:'circle',
          itemGap: 20,
        },
        //提示框
        tooltip: {
          trigger: 'axis',
        },
        // x轴
        xAxis: {
          type: 'category',
          data: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
          boundaryGap: false,
        },
        // y轴
        yAxis: {
          type: 'value',
        },
        // 数据
        series: [
          {
            name: '二维预案',
            type: 'line',
            symbolSize: 0,
            smooth:true,
            lineStyle:{
              width: 4,
              color: {
                type: 'linear',
                x: 0,
                y: 0,
                x2: 1,
                y2: 0,
                colorStops: [{
                  offset: 0,
                  color: 'rgba(254,51,194,0)' // 0% 处的颜色
                }, {
                  offset: 0.5,
                  color: 'rgba(254,51,194,1)' // 100% 处的颜色
                }, {
                  offset: 1,
                  color: 'rgba(254,51,194,0)' // 100% 处的颜色
                }],
                global: false // 缺省为 false
              }
            },
            data: [238, 242, 146, 240, 135, 130, 138, 142, 246, 140, 235, 130 ],
          },
          {
            name: '三维预案',
            type: 'line',
            symbolSize: 0,
            smooth:true,
            lineStyle:{
              width: 4,
              color: {
                type: 'linear',
                x: 0,
                y: 0,
                x2: 1,
                y2: 0,
                colorStops: [{
                  offset: 0,
                  color: 'rgba(14,222,252,0)' // 0% 处的颜色
                }, {
                  offset: 0.5,
                  color: 'rgba(0,221,255,1)' // 100% 处的颜色
                }, {
                  offset: 1,
                  color: 'rgba(1,255,253,0)' // 100% 处的颜色
                }],
                global: false // 缺省为 false
              },
            },
            data: [282, 122, 126, 220, 125, 120, 228, 216, 230, 255, 250, 138 ],
          },
          {
            name: '卡片预案',
            type: 'line',
            symbolSize: 0,
            smooth:true,
            lineStyle:{
              width: 4,
              color: {
                type: 'linear',
                x: 0,
                y: 0,
                x2: 1,
                y2: 0,
                colorStops: [{
                  offset: 0,
                  color: 'rgba(48,63,240,0)' // 0% 处的颜色
                }, {
                  offset: 0.5,
                  color: 'rgba(48,63,240,1)' // 100% 处的颜色
                }, {
                  offset: 1,
                  color: 'rgba(48,63,240,0)' // 100% 处的颜色
                }],
                global: false // 缺省为 false
              },
            },
            data: [228, 212, 166, 150, 125, 240, 148, 128, 212, 166, 150, 225 ],
          },
          {
            name: '其他预案',
            type: 'line',
            symbolSize: 0,
            smooth:true,
            lineStyle:{
              width: 4,
              color: {
                type: 'linear',
                x: 0,
                y: 0,
                x2: 1,
                y2: 0,
                colorStops: [{
                  offset: 0,
                  color: 'rgba(185,48,45,0)' // 0% 处的颜色
                }, {
                  offset: 0.5,
                  color: 'rgba(185,48,45,1)' // 100% 处的颜色
                }, {
                  offset: 1,
                  color: 'rgba(185,48,45,0)' // 100% 处的颜色
                }],
                global: false // 缺省为 false
              },
            },
            data: [145, 252, 130, 266, 299, 289, 156, 123, 212, 252, 188, 198 ],
          },
        ],
    };
    chartYalxtjOption2:any = {
      color: ['#FB33C2', '#00CFF0', '#2C3DE0','#b9302d'],
      grid: {
        top: 50,
        left: 30,
        right: 20,
        bottom: 20,
      },
      // 标题
      title: {
        text: '预案类型统计',
        top: -4,
        left: 0
      },
      //图例
      legend: {
        top: 0,
        data: ['二维预案', '三维预案', '卡片预案', '其他预案'],
        icon:'circle',
        itemGap: 20,
      },
      //提示框
      tooltip: {
        trigger: 'axis',
      },
      // x轴
      xAxis: {
        type: 'category',
        data: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
        boundaryGap: false,
      },
      // y轴
      yAxis: {
        type: 'value',
      },
      // 数据
      series: [
        {
          name: '二维预案',
          type: 'line',
          symbolSize: 0,
          smooth:true,
          lineStyle:{
            width: 4,
            color: {
              type: 'linear',
              x: 0,
              y: 0,
              x2: 1,
              y2: 0,
              colorStops: [{
                offset: 0,
                color: 'rgba(254,51,194,0)' // 0% 处的颜色
              }, {
                offset: 0.5,
                color: 'rgba(254,51,194,1)' // 100% 处的颜色
              }, {
                offset: 1,
                color: 'rgba(254,51,194,0)' // 100% 处的颜色
              }],
              global: false // 缺省为 false
            }
          },
          data: [66, 25, 85, 41, 68, 78, 65, 35, 25, 56, 68, 99 ],
        },
        {
          name: '三维预案',
          type: 'line',
          symbolSize: 0,
          smooth:true,
          lineStyle:{
            width: 4,
            color: {
              type: 'linear',
              x: 0,
              y: 0,
              x2: 1,
              y2: 0,
              colorStops: [{
                offset: 0,
                color: 'rgba(14,222,252,0)' // 0% 处的颜色
              }, {
                offset: 0.5,
                color: 'rgba(0,221,255,1)' // 100% 处的颜色
              }, {
                offset: 1,
                color: 'rgba(1,255,253,0)' // 100% 处的颜色
              }],
              global: false // 缺省为 false
            },
          },
          data: [45, 52, 130, 66, 99, 89, 56, 123, 112, 152, 88, 98 ],
        },
        {
          name: '卡片预案',
          type: 'line',
          symbolSize: 0,
          smooth:true,
          lineStyle:{
            width: 4,
            color: {
              type: 'linear',
              x: 0,
              y: 0,
              x2: 1,
              y2: 0,
              colorStops: [{
                offset: 0,
                color: 'rgba(48,63,240,0)' // 0% 处的颜色
              }, {
                offset: 0.5,
                color: 'rgba(48,63,240,1)' // 100% 处的颜色
              }, {
                offset: 1,
                color: 'rgba(48,63,240,0)' // 100% 处的颜色
              }],
              global: false // 缺省为 false
            },
          },
          data: [26, 72, 66, 50, 25, 40, 48, 66, 50, 25, 40, 48  ],
        },
        {
          name: '其他预案',
          type: 'line',
          symbolSize: 0,
          smooth:true,
          lineStyle:{
            width: 4,
            color: {
              type: 'linear',
              x: 0,
              y: 0,
              x2: 1,
              y2: 0,
              colorStops: [{
                offset: 0,
                color: 'rgba(185,48,45,0)' // 0% 处的颜色
              }, {
                offset: 0.5,
                color: 'rgba(185,48,45,1)' // 100% 处的颜色
              }, {
                offset: 1,
                color: 'rgba(185,48,45,0)' // 100% 处的颜色
              }],
              global: false // 缺省为 false
            },
          },
          data: [56, 52, 55, 66, 99, 89, 102, 36, 56, 102, 66, 68 ],
        },
      ],
    };
    map:any; //地图
    newallorganizations:any //带有children的组织机构
    ngOnInit(): void {
      //获取所有组织机构
      this.http.get('/api/Organizations').subscribe(data=>{
        this.newallorganizations = data
        this.newallorganizations.forEach(item => {
          item.children = []
          this.newallorganizations.forEach(element => {
            if(element.parentId == item.id){
              item.children.push(element)
            }
          });
        });
      })
      setTimeout(() => {
          this.getEcharts()
          this.mapInit() //初始化地图
          this.chartsSetOption('','province')
      }, 0);
    }
    
    //初始化图表
    getEcharts(){
      this.chartQusj = echarts.init(this.element.nativeElement.querySelector('#chartQusj'),'skinUpp');
      this.chartYadwlx = echarts.init(this.element.nativeElement.querySelector('#chartYadwlx'),'skinUpp');
      this.chartYapyph = echarts.init(this.element.nativeElement.querySelector('#chartYapyph'),'skinUpp');
      this.chartYalxtj = echarts.init(this.element.nativeElement.querySelector('#chartYalxtj'),'skinUpp'); 
    }
    
     

    //初始化地图
    adcode:any = 310000 //行政编码 
    mapInit () {
      //创建地图
      this.map = new AMap.Map('chartMap', {
        cursor: 'default',
        zooms:[6,18],
        mapStyle:"amap://styles/grey", 
        // bubble: true
      });
  
      let colors = [
        "#3366cc", "#dc3912", "#ff9900", "#109618", "#990099", "#0099c6", "#dd4477", "#66aa00",
        "#b82e2e", "#316395", "#994499", "#22aa99", "#aaaa11", "#6633cc", "#e67300", "#8b0707",
        "#651067", "#329262", "#5574a6", "#3b3eac"
      ];
      
      AMapUI.loadUI(['geo/DistrictExplorer'], (DistrictExplorer)=> {
  
        //创建一个实例
        let districtExplorer = new DistrictExplorer({
          map: this.map,
          eventSupport: true, //打开事件支持
        });

        let adcode = this.adcode; //行政编码 
        districtExplorer.loadAreaNode(adcode, (error, areaNode)=> {
            //更新地图视野
            // this.map.setBounds(areaNode.getBounds(), null, null, true);

            //设置定位节点，支持鼠标位置识别
            //注意节点的顺序，前面的高优先级
            districtExplorer.setAreaNodesForLocating(areaNode);

            //清除已有的绘制内容
            districtExplorer.clearFeaturePolygons();
    
            //绘制子区域
            districtExplorer.renderSubFeatures(areaNode, (feature, i) =>{

              let fillColor = colors[i % colors.length];
              let strokeColor = colors[colors.length - 1 - i % colors.length];
    
              return {
                  cursor: 'default',
                  bubble: true,
                  strokeColor: strokeColor, //线颜色
                  strokeOpacity: 1, //线透明度
                  strokeWeight: 1, //线宽
                  fillColor: fillColor, //填充色
                  fillOpacity: 0.7, //填充透明度
              };
            });
    
            //绘制父区域
            districtExplorer.renderParentFeature(areaNode, {
              cursor: 'default',
              bubble: true,
              strokeColor: 'black', //线颜色
              strokeOpacity: 1, //线透明度
              strokeWeight: 1, //线宽
              fillColor: null, //填充色
              fillOpacity: 0.5, //填充透明度
            });

            // 更新地图视野以适合区划面
            this.map.setFitView(districtExplorer.getAllFeaturePolygons());
        });

        districtExplorer.on('featureClick', (e, feature) =>{
          
          let props = feature.properties;
          adcode = props.adcode
          // (123,feature)
          let fillColor2
          if(props.level == 'city'){
              fillColor2 = null
              let adcode = feature.properties.adcode
              this.newallorganizations.forEach(item => {
                if(item.division.indexOf(adcode) != -1){
                  // console.log(item)
                  let orArr = []
                  for(let i = 0; i < 6; i++){
                    orArr.unshift(item.children[i].name)
                  }
                  this.chartYapyphOption2.yAxis.data = orArr
                  this.chartYapyphOption2.series[0].data = [12, 14, 18, 24, 26, 30]
                  this.chartsSetOption(item.id,"city")
                  
                }
              });
          }else{
              fillColor2 = '#d0daee'
          }
          districtExplorer.loadAreaNode(adcode, (error, areaNode)=> {
            //更新地图视野
            // this.map.setBounds(areaNode.getBounds(), null, null, true);

            //设置定位节点，支持鼠标位置识别
            //注意节点的顺序，前面的高优先级
            districtExplorer.setAreaNodesForLocating(areaNode);

            //清除已有的绘制内容
            districtExplorer.clearFeaturePolygons();
    
            //绘制子区域
            districtExplorer.renderSubFeatures(areaNode, (feature, i) =>{
              let fillColor = colors[i % colors.length];
              // console.log(111,fillColor)
              let strokeColor = colors[colors.length - 1 - i % colors.length];
    
              return {
                  cursor: 'default',
                  bubble: true,
                  strokeColor: strokeColor, //线颜色
                  strokeOpacity: 1, //线透明度
                  strokeWeight: 1, //线宽
                  fillColor: fillColor, //填充色
                  fillOpacity: 0.7, //填充透明度
              };
            });
    
            //绘制父区域
            districtExplorer.renderParentFeature(areaNode, {
              cursor: 'default',
              bubble: true,
              strokeColor: 'black', //线颜色
              strokeOpacity: 1, //线透明度
              strokeWeight: 1, //线宽
              fillColor: fillColor2, //填充色
              fillOpacity: 0.5, //填充透明度
            });

            // 更新地图视野以适合区划面
            this.map.setFitView(districtExplorer.getAllFeaturePolygons());
          });
        });

        districtExplorer.on('outsideClick', (e) => {
          // console.log('区域外点击');
          this.chartsSetOption('','province')
          adcode = 310000
          districtExplorer.loadAreaNode(adcode, (error, areaNode)=> {
            //更新地图视野
            // this.map.setBounds(areaNode.getBounds(), null, null, true);

            //设置定位节点，支持鼠标位置识别
            //注意节点的顺序，前面的高优先级
            districtExplorer.setAreaNodesForLocating(areaNode);

            //清除已有的绘制内容
            districtExplorer.clearFeaturePolygons();
    
            //绘制子区域
            districtExplorer.renderSubFeatures(areaNode, (feature, i) =>{
              let fillColor = colors[i % colors.length];
              // console.log(111,fillColor)
              let strokeColor = colors[colors.length - 1 - i % colors.length];
    
              return {
                  cursor: 'default',
                  bubble: true,
                  strokeColor: strokeColor, //线颜色
                  strokeOpacity: 1, //线透明度
                  strokeWeight: 1, //线宽
                  fillColor: fillColor, //填充色
                  fillOpacity: 0.7, //填充透明度
              };
            });
    
            //绘制父区域
            districtExplorer.renderParentFeature(areaNode, {
              cursor: 'default',
              bubble: true,
              strokeColor: 'black', //线颜色
              strokeOpacity: 1, //线透明度
              strokeWeight: 1, //线宽
              fillColor: null, //填充色
              fillOpacity: 0.5, //填充透明度
            });

            // 更新地图视野以适合区划面
            this.map.setFitView(districtExplorer.getAllFeaturePolygons());
          });
          // this.chartQusj.setOption(this.chartQusjOption);
          // this.chartYadwlx.setOption(this.chartYadwlxOption);
          // this.chartYapyph.setOption(this.chartYapyphOption);
          // this.chartYalxtj.setOption(this.chartYalxtjOption);
          // this.keyUnitNum = '13,036'
          // this.dataNum = '7,999'
          // this.planNum = '33,678'
        })
        
      });


    }
    
    //设置真实数据
    chartsSetOption(id,isCity){ 
      this.http.get("/api/StatisticsAnalysis",{params:{OrganizationId:id}}).subscribe((data:any)=>{
        // console.log(888,data)
        this.dataNum = data.companyStatistics.totalCount //重点单位数量
        this.planNum = data.planStatistics.totalCount //预案数量
        
        //预案单位类型统计
        this.unitTypeStatistics = data.planStatistics.buildingTypeStatistics.buildingTypes
        this.unitTypeStatistics.forEach(item => {
          item.name = item.buildingTypeName
          item.value = item.count
        });
        this.data02 = this.unitTypeStatistics
        this.chartYadwlxOption.series[0].data = this.unitTypeStatistics
        this.chartYadwlx.setOption(this.chartYadwlxOption,true);

        //全队数据采集和预案编制数量统计
        this.chartQusjData = data.planStatistics.buildingTypeStatistics.buildingTypes
        let data1 = []
        data.companyStatistics.trendStatistics.added.forEach(item => {
          data1.push(item.count)
        });
        let data2 = []
        data.planStatistics.trendStatistics.added.forEach(item => {
          data2.push(item.count)
        });
        this.chartQusjOption.series[0].data = data2
        this.chartQusjOption.series[1].data = data1
        this.chartQusj.setOption(this.chartQusjOption,true);
      })
      if(isCity == "city"){//如果是城市级别
        this.keyUnitNum = 100
        this.chartYapyph.setOption(this.chartYapyphOption2);
        this.chartYalxtj.setOption(this.chartYalxtjOption2);

      }else{
        this.keyUnitNum = 1500
        this.chartYapyph.setOption(this.chartYapyphOption);
        this.chartYalxtj.setOption(this.chartYalxtjOption);
      }
    }
}
