import { Component, OnInit ,ViewChild, AfterViewInit,ElementRef,Renderer2  } from '@angular/core';
import { HttpClient } from '@angular/common/http'
import { Router,ActivatedRoute } from '@angular/router'
declare var echarts: any;
declare var AMap: any;

declare var AMapUI: any;


@Component({
  selector: 'app-homedetail',
  templateUrl: './homedetail.component.html',
  styleUrls: ['./homedetail.component.scss']
})
export class HomedetailComponent implements OnInit {

  constructor(private http:HttpClient, private render2: Renderer2,public element: ElementRef,private router:Router,private route:ActivatedRoute) { }

   //全队数据采集和预案编制数量统计
   chartQusj:any
   chartQusjOption:any = {
       
       grid: {
       top: 50,
       left: 30,
       right: 20,
       bottom: 20,
       },
       // 标题
       title: {
       text: '全队数据采集和预案编制数量统计',
       top: -4,
       left:-2
       },
       //图例
       legend: {
       top: 0,
       right:-2,
       //   left:3,
       data: ['单位预案编制数量', '单位数据采集数量'],
       },
       //提示框
       tooltip: {
       trigger: 'axis',
       },
       // x轴
       xAxis: {
       type: 'category',
       data: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
       boundaryGap: false,
       },
       // y轴
       yAxis: {
       type: 'value',
       name:'个'
       },
       // 数据
       series: [
       {
           name: '单位预案编制数量',
           type: 'line',
           data: [38, 42, 46, 40, 35, 30, 38, 38, 42, 46, 40, 35],
           // showSymbol: true,
           // symbolSize:6,
           // smooth: false,
           // label: {
           //   show: true,
           // },
           areaStyle: {
           color: {
               type: 'linear',
               x: 0,
               y: 0,
               x2: 0,
               y2: 1,
               colorStops: [{
               offset: 0,
               color: 'rgba(60,103,195,1)' // 0% 处的颜色
               }, {
               offset: 1,
               color: 'rgba(0,194,255,.2)' // 100% 处的颜色
               }],
               global: false // 缺省为 false
           }
           }
       },
       {
           name: '单位数据采集数量',
           type: 'line',
           data: [28, 12, 66, 50, 25, 40, 48, 12, 66, 50, 25, 40 ],
       },
       ],
   };
   //预案单位类型统计
   chartYadwlx:any
   data02:any = [{
   value: 335,
   name: '类型名称1'
 },
 {
   value: 110,
   name: '类型名称2'
 },
 {
   value: 274,
   name: '类型名称3'
 },
 {
   value: 235,
   name: '视频广告'
 },
 {
   value: 400,
   name: '类型名称4'
 }
   ];
   chartYadwlxOption:any = {
       // 标题
       title: {
       text: '预案单位类型统计',
       left: '15%',
       top:0
       },
       //图例
       legend: {
       orient: 'vertical',
       top: 'center',
       right: '0%',
       show: false,
       formatter: function (name) {
           var target;
           for (var i = 0, l = this.data02.length; i < l; i++) {
           if (this.data02[i].name == name) {
               target = this.data02[i].value;
           }
           }
           return name + ' ' + target;
       }
       },
       //提示框
       tooltip: {
       trigger: 'item',
       },
       // 数据
       series: [{
       type: 'pie',
       center: ['55%', '55%'],
       radius: ['25%', '60%'],
       roseType:true,
       // labelLine: {
       //   show: true,
       //   length: 20,
       //   length2: 0,
       //   lineStyle: {
       //     color: '#999',
       //     width: 1
       //   }
       // },
       labelLine:{
           lineStyle:{
           color: '#93FCFF'
           }
       },
       label: {
           //formatter: '{hr|}\n{a|{b}}\n{b|{c}}万吨\n{c|{d}%}',
           formatter: '{a|{b}}\n{b|{c}}{c|万吨}\n{d|{d}%}',
           rich: {
           // hr: {
           //   borderColor: '#999',
           //   width: '100%',
           //   borderWidth: 1,
           //   marginLeft: '-15px',
           //   marginRight: '-15px',
           //   height:0 
           // },
           a: {
               color: '#1F6F9B',
               fontSize: 12,
               height: 18,
               borderColor: '#999',
               //marginTop: '65px',
           },
           b: {
               color: '#fff',
               fontSize: 24,
               height: 36,
           },
           c: {
               color: '#fff',
               fontSize: 12,
           },
           d: {
               color: '#fff',
               fontSize: 12,
               height: 16,
               marginLeft: '5px',
           },
           },
       },
       data: [{
           value: 335,
           name: '类型名称1'
           },
           {
           value: 110,
           name: '类型名称2'
           },
           {
           value: 274,
           name: '类型名称3'
           },
           {
           value: 235,
           name: '类型名称4'
           }
       ],
       }],
   };
   // 预案评优排行
   chartYapyph:any
   chartYapyphOption:any = {
       // 标题
       title: {
         text: '预案评优排行',
         left:0
       },
       grid: {
         left: 30,
         right: 0,
       },
       //提示框
       tooltip: {
         trigger: 'axis',
       },
       // x轴
       xAxis: {
         type: 'category',
         data: ['机构1', '机构2', '机构3', '机构4', '机构5', '机构6', '机构7']
       },
       // y轴
       yAxis: {
         type: 'value',
         splitLine: {
           show: true,
           lineStyle: {
             color: '#fff'
           }
         },
       },
       // 数据
       series: [{
           name: '预案评优',
           type: 'bar',
           data: [320, 302, 301, 234, 390, 330, 320],
           label: {
             show: false,
             position: "top",
             formatter: '{c}',
             color: "#fff",
           },
           itemStyle: {
             color: {
               type: 'linear',
               x: 0,
               y: 0,
               x2: 0,
               y2: 1,
               colorStops: [{
                 offset: 0,
                 color: 'rgba(0,220,254,1)' // 0% 处的颜色
               }, {
                 offset: 1,
                 color: 'rgba(1,104,191,1)' // 100% 处的颜色
               }],
               globalCoord: false // 缺省为 false
             },
           }
         }
       ],
   };
   //预案类型统计
   chartYalxtj:any
   chartYalxtjOption:any = {
       color: ['#FB33C2', '#00CFF0', '#2C3DE0'],
       grid: {
         top: 50,
         left: 30,
         right: 20,
         bottom: 20,
       },
       // 标题
       title: {
         text: '预案类型统计',
         top: -4,
         left: 0
       },
       //图例
       legend: {
         top: 0,
         data: ['二维预案', '三维预案', '卡片预案'],
         icon:'circle',
         itemGap: 20,
       },
       //提示框
       tooltip: {
         trigger: 'axis',
       },
       // x轴
       xAxis: {
         type: 'category',
         data: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
         boundaryGap: false,
       },
       // y轴
       yAxis: {
         type: 'value',
       },
       // 数据
       series: [{
           name: '二维预案',
           type: 'line',
           symbolSize: 0,
           smooth:true,
           lineStyle:{
             width: 4,
             color: {
               type: 'linear',
               x: 0,
               y: 0,
               x2: 1,
               y2: 0,
               colorStops: [{
                 offset: 0,
                 color: 'rgba(254,51,194,0)' // 0% 处的颜色
               }, {
                 offset: 0.5,
                 color: 'rgba(254,51,194,1)' // 100% 处的颜色
               }, {
                 offset: 1,
                 color: 'rgba(254,51,194,0)' // 100% 处的颜色
               }],
               global: false // 缺省为 false
             }
           },
           data: [38, 42, 46, 40, 35, 30, 38, 42, 46, 40, 35, 30 ],
         },
         {
           name: '三维预案',
           type: 'line',
           symbolSize: 0,
           smooth:true,
           lineStyle:{
             width: 4,
             color: {
               type: 'linear',
               x: 0,
               y: 0,
               x2: 1,
               y2: 0,
               colorStops: [{
                 offset: 0,
                 color: 'rgba(14,222,252,0)' // 0% 处的颜色
               }, {
                 offset: 0.5,
                 color: 'rgba(0,221,255,1)' // 100% 处的颜色
               }, {
                 offset: 1,
                 color: 'rgba(1,255,253,0)' // 100% 处的颜色
               }],
               global: false // 缺省为 false
             },
           },
           data: [28, 72, 66, 50, 25, 40, 48, 66, 50, 25, 40, 48 ],
         },
         {
           name: '卡片预案',
           type: 'line',
           symbolSize: 0,
           smooth:true,
           lineStyle:{
             width: 4,
             color: {
               type: 'linear',
               x: 0,
               y: 0,
               x2: 1,
               y2: 0,
               colorStops: [{
                 offset: 0,
                 color: 'rgba(48,63,240,0)' // 0% 处的颜色
               }, {
                 offset: 0.5,
                 color: 'rgba(48,63,240,1)' // 100% 处的颜色
               }, {
                 offset: 1,
                 color: 'rgba(48,63,240,0)' // 100% 处的颜色
               }],
               global: false // 缺省为 false
             },
           },
           data: [28, 112, 166, 150, 125, 140, 48, 28, 112, 166, 150, 125 ],
         },
       ],
   };
   //地图
   
   chartMap:any
   chartMapOption:any = {
       tooltip: {
         show: true,
         formatter: function (params) {
           return params.name + '：' + params.data['value'];
         },
       },
       geo: [{
           show: true,
           map: 'chongqing',
           zoom: 1,
           itemStyle: {
             areaColor: '#090C15',
             borderColor: '#0584DD',
             borderWidth: 2,
             shadowColor: 'rgba(5, 132, 221, 1)',
             shadowBlur: 1,
             shadowOffsetX: 2,
             shadowOffsetY: 10,
           },
           emphasis: {
             label: {
               color: '#fff',
             },
             itemStyle: {
               areaColor: '#0584DD',
             }
           }
         },
         {
           show: true,
           map: 'chongqing',
           label: {
             show: true,
             color: '#fff',
             fontSize: 12,
           },
           zoom: 1,
           itemStyle: {
             areaColor: '#090C15',
             borderColor: '#0584DD',
           },
           emphasis: {
             label: {
               color: '#fff',
             },
             itemStyle: {
               areaColor: '#0584DD',
             }
           }
         }
       ]
   }

   ngOnInit(): void {
       setTimeout(() => {
           this.chartQusj = echarts.init(this.element.nativeElement.querySelector('#chartQusj'),'skinUpp');
           this.chartQusj.setOption(this.chartQusjOption);
           this.chartYadwlx = echarts.init(this.element.nativeElement.querySelector('#chartYadwlx'),'skinUpp');
           this.chartYadwlx.setOption(this.chartYadwlxOption);
           this.chartYapyph = echarts.init(this.element.nativeElement.querySelector('#chartYapyph'),'skinUpp');
           this.chartYapyph.setOption(this.chartYapyphOption);
           this.chartYalxtj = echarts.init(this.element.nativeElement.querySelector('#chartYalxtj'),'skinUpp');
           this.chartYalxtj.setOption(this.chartYalxtjOption);
           this.chartMap = echarts.init(this.element.nativeElement.querySelector('#chartMap'));
          //  console.log(this.chartMapOption)
           this.chartMap.setOption(this.chartMapOption);
           this.mapInit() //初始化地图
       }, 0);
      //  console.log(echarts)
   }
   mapInit () {

    //创建地图
    var map = new AMap.Map('chartMap', {
      cursor: 'default',
      zooms:[7,10],
      mapStyle:"amap://styles/grey",
      
    });
 
    var colors = [
      "#3366cc", "#dc3912", "#ff9900", "#109618", "#990099", "#0099c6", "#dd4477", "#66aa00",
      "#b82e2e", "#316395", "#994499", "#22aa99", "#aaaa11", "#6633cc", "#e67300", "#8b0707",
      "#651067", "#329262", "#5574a6", "#3b3eac"
    ];
 
    AMapUI.loadUI(['geo/DistrictExplorer'], (DistrictExplorer)=> {
 
     //创建一个实例
     var districtExplorer = new DistrictExplorer({
       map: map,
       eventSupport: true, //打开事件支持
     });
   
     var adcode = this.route.snapshot.queryParams.code;
 
     districtExplorer.loadAreaNode(adcode, (error, areaNode)=>{
         
         //更新地图视野
         map.setBounds(areaNode.getBounds(), null, null, true);
 
         //清除已有的绘制内容
         districtExplorer.clearFeaturePolygons();
 
         //绘制子区域
         districtExplorer.renderSubFeatures(areaNode, (feature, i) => {
          //  console.log(123,feature,i)
           var fillColor = colors[i % colors.length];
           var strokeColor = colors[colors.length - 1 - i % colors.length];
 
           return {
               cursor: 'default',
               bubble: true,
               strokeColor: strokeColor, //线颜色
               strokeOpacity: 1, //线透明度
               strokeWeight: 1, //线宽
               fillColor: fillColor, //填充色
               fillOpacity: 0.5, //填充透明度
           };
         });
         
         let fillColor2
         if(this.route.snapshot.queryParams.level == 'city'){
            fillColor2 = null
         }else{
            fillColor2 = '#329262'
         }
        //  console.log(789,fillColor2)
         //绘制父区域
         districtExplorer.renderParentFeature(areaNode, {
           cursor: 'default',
           bubble: true,
           strokeColor: 'black', //线颜色
           strokeOpacity: 1, //线透明度
           strokeWeight: 1, //线宽
           fillColor: fillColor2, //填充色
           fillOpacity: 0.5, //填充透明度
         });
 
       });
        districtExplorer.on('featureClick', function(e, feature) {
          var props = feature.properties;
          // //如果存在子节点
          // // if (props.childrenNum > 0) {
          //     //切换聚焦区域
          //     switch2AreaNode(props.adcode);
          // // }
          // console.log(props)
        });


    });
 
   }
}
