import { HttpClient } from "@angular/common/http";
import { Component, OnInit, Inject } from "@angular/core";
import { MatDialogRef, MAT_DIALOG_DATA } from "@angular/material/dialog";
import { MatSnackBar } from "@angular/material/snack-bar";

@Component({
  selector: "app-edit-plan-category",
  templateUrl: "./edit-plan-category.component.html",
  styleUrls: ["./edit-plan-category.component.scss"],
})
export class EditPlanCategoryComponent implements OnInit {
  constructor(
    private http: HttpClient,
    public dialogRef: MatDialogRef<EditPlanCategoryComponent>,
    @Inject(MAT_DIALOG_DATA) public data,
    public snackBar: MatSnackBar
  ) {}
  planCategory;
  ngOnInit(): void {
    this.planCategory = this.data.planCategory;
  }

  onNoClick(): void {
    this.dialogRef.close();
  }

  onSubmit(value) {
    let body = {
      planCategory: this.planCategory,
    };
    this.http
      .put(`/api/PlanComponents/${this.data.id}`, body)
      .subscribe((data) => {
        this.dialogRef.close("success");
      });
  }
}
