import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { ActivatedRoute } from '@angular/router';
import {EchartsDataService} from '../../echarts-data.service';
import { MatDialogRef, MatDialog, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { CompangInfoComponent } from '../../compang-info/compang-info.component'
declare var echarts: any;
@Component({
  selector: 'app-add-unit-two-type-details',
  templateUrl: './add-unit-two-type-details.component.html',
  styleUrls: ['./add-unit-two-type-details.component.scss']
})
export class AddUnitTwoTypeDetailsComponent implements OnInit {

  constructor(public route: ActivatedRoute,private router: Router,public dialog: MatDialog,public echartsData:EchartsDataService) { }
  forward(){
    this.router.navigate(['/statisticanalysis/addUnit_one/addUnit_two_type'])
  }
  reverse(){
    this.router.navigate(['/statisticanalysis/addUnit_one/addUnit_two_time'])
  }
  //返回
  goBack () {
    sessionStorage.setItem('refresh', 'true');
    history.go(-1);
    this.echartsData.statefulInspectionToggle = true
  }

  organizationName:String
  buildingTypeName:String
  setTimeoutObj//延时器需要清除
  lastId
  canshuId
  tabledata
  thisorId=[]
  zhiorbuild
  padHw
  ngOnInit(): void {
    if(window.matchMedia("(max-width: 1400px)").matches){
      this.padHw=true
      //this.padjt=
    }else{
      this.padHw=false
    }
    if(sessionStorage.getItem('refresh') === 'true') {
      sessionStorage.removeItem('refresh');
      location.reload();
     }
    this.route.queryParams.subscribe(params => {
      this.organizationName = params['organizationName'];
      this.buildingTypeName = params['buildingTypeName'];
      this.lastId=params['id']
      this.canshuId=params['zhuId']
      this.zhiorbuild=params['type']
    });
    
    this.setTimeoutObj = window.setTimeout(()=>{
      this.getechartsData()
    })
  }
  async getechartsData(){
    let paramsdata:any /* = {
      organizationId:this.zhiorbuild=='zhi'?this.lastId:this.canshuId
    } */
    if(this.echartsData.addYear==undefined&&this.echartsData.addMonth!=undefined){
      this.echartsData.addYear=new Date().getFullYear()
      paramsdata={
        organizationId:this.zhiorbuild=='zhi'?this.lastId:this.canshuId,
        TimeIntervalStart:this.echartsData.addYear+'-'+this.echartsData.addMonth,
        TimeIntervalEnd:this.echartsData.addYear+'-'+this.echartsData.addMonth,
      }
    }else if(this.echartsData.addYear==undefined&&this.echartsData.addMonth==undefined){
      paramsdata={
        organizationId:this.zhiorbuild=='zhi'?this.lastId:this.canshuId,
      }
    }else{
      paramsdata={
        organizationId:this.zhiorbuild=='zhi'?this.lastId:this.canshuId,
        TimeIntervalStart:this.echartsData.addYear+'-'+this.echartsData.addMonth,
        TimeIntervalEnd:this.echartsData.addYear+'-'+this.echartsData.addMonth,
      }
    }
    await this.echartsData.getData(paramsdata,`/api/StatisticsAnalysis/Companies/BuildingTypes/${this.zhiorbuild=='zhi'?this.canshuId:this.lastId}`)
    this.tabledata=JSON.parse(JSON.stringify(this.echartsData.allDate))
      //console.log(this.tabledata)
      for(var i=0;i<this.tabledata[0].organizations.length;i++){
        this.zhongNameData.push(this.tabledata[0].organizations[i].organizationName)
        this.zhongNumData.push(this.tabledata[0].organizations[i].count)
        this.thisorId.push(this.tabledata[0].organizations[i].organizationId)
      }
      this.tiaoshiPao=this.echartsData.qipao(this.tiaoshiPao,this.zhongNumData,this.zhongNameData)
      this.detailEcharts()
  }
  ngOnDestroy(){
    window.clearTimeout(this.setTimeoutObj);
    this.detailPlanEchart.clear()
    this.detailPlanEchart.dispose()
  }
  topTextlabel = {
    show: true, // 开启显示
    position: 'top', // 在上方显示
    distance: 10, // 距离图形元素的距离。当 position 为字符描述值（如 'top'、'insideRight'）时候有效。
    verticalAlign: 'middle',
    textStyle: { // 数值样式
      color: 'black',
      fontSize: 12
    }
  }//柱状图数值顶部显示
  zhongNameData = []
  zhongNumData = []
  tiaoshiPao:any
  //气泡提示数据获取
  bianli(){
    if(this.zhongNumData.length>=1){
      var arrshuzu='[';
    for(var i=0;i<this.zhongNumData.length;i++){
      arrshuzu+='{"value":'+this.zhongNumData[i]+',"coord":['+i+','+this.zhongNumData[i]+'],"name":'+'"'+this.zhongNameData[i]+'"'+'},'
    }
    arrshuzu=arrshuzu.substring(0,arrshuzu.length-1)
    arrshuzu+=']'
    this.tiaoshiPao=JSON.parse(arrshuzu)
    }
    
    //return tishiPao
  }

  detailPlanEchart//echarts实例
  detailEcharts(){
    this.detailPlanEchart = echarts.init(document.getElementById('barEchart'),'walden');  
    var option = {
      title: {
        text: this.buildingTypeName + '(' +this.organizationName + ')'+`：总数(${this.tabledata[0].totalCount})`,
        left: "center",
        //top: "15%",
        textStyle: {
          fontSize: 30
        }
      },
      grid: {
        top:'16%',
        bottom: '23%',
        //bottom: 10
       },
      xAxis: {
          id:this.thisorId,
          type: 'category',
          data: this.zhongNameData,
          axisLabel:{
            //this.axisLabel,
            rotate:38,
            textStyle:{
              fontSize :15,
              color:'#000000'
            }
            
          }
      },
      yAxis: {
          type: 'value',
          axisLabel:{
            //this.axisLabel,
            textStyle:{
              fontSize :18,
              color:'#000000'
            }
            
          }
      },
      tooltip: {
        trigger: 'item',
        formatter:  (params)=>{
          return this.echartsData.biaogeTishida(params)
        }
      },
      series: [{
          data: this.zhongNumData,
          type: 'bar',
          markPoint: {
            symbolSize:[65, 65],
            data: this.tiaoshiPao
        },
          barWidth :'38',
          backgroundStyle: {
              color: 'rgba(220, 220, 220, 0.8)'
          },
          //label: this.topTextlabel
      }]
    };
    this.detailPlanEchart.setOption(option);
    this.detailPlanEchart.getZr().on('click', (params) => {
    const pointInPixel= [params.offsetX, params.offsetY];
      if (this.detailPlanEchart.containPixel('grid',pointInPixel)){
        let xIndex=this.detailPlanEchart.convertFromPixel({seriesIndex:0},[params.offsetX, params.offsetY])[0];
        
        if((this.echartsData.level=='0'||this.echartsData.level=='1')&&this.tabledata[0].organizations[xIndex].subOrganizations.length>=1){
          //总队和支队跳转
          this.router.navigate(['/statisticanalysis/addUnit_one/addUnit_two_time/three_barDetails'],{queryParams:{'time':'','buildingTpye':option.xAxis.data[xIndex]+this.organizationName,'zhuid':option.xAxis.id[xIndex],'id':this.zhiorbuild=='zhi'?this.canshuId:this.lastId,'type':this.zhiorbuild=='zhi'?'zhi':'build'}});
        }else{
          this.router.navigate(['/statisticanalysis/CompangInfo'],{queryParams:{'name':option.xAxis.data[xIndex],'type':1,'jsid':option.xAxis.id[xIndex],'buildid':this.zhiorbuild=='zhi'?this.canshuId:this.lastId}});
        }
      }
      
    });
  }

 
  tableTooltip(params:any){
    var data = [
      {name:params.name,number:params.value,zhanbi:(params.value/1340 * 100).toFixed(2) + "%"}
    ]
    var res = '<div class="tishi" style=" backgroundColor:rgba(255,255,255,1);width:100%;height:100%;"><div style="padding:10px 0 5px 0"><span style="color:#FFFFFF;font-size:27px;text-align: center;display:block;">'+params.name+'</span></div>'
        res+='</br><div style="width:300px;height:100%;padding:0 20px 15px 20px"><table style="width:300px;font-size:16px;  color:#FFFFFF;border-collapse:collapse;"cellspacing="0"; >';
        res+='<thead style="font-size:18px;"><tr>';
        res+='<td style="text-align:center;width:30%;">名称</td>';
        res+='<td style="text-align:center;width:30%;">数量</td>'
        res+='<td style="text-align:center;width:30%;">总占比</td>'
        res+='</tr></thead>'
        res+='<tbody>';
        for(var i=0;i<data.length;i++){
          res+='<tr>'
          res+='<td style="text-align:center;">'+data[i].name+'</td>'
          res+='<td style="text-align:center;">'+data[i].number+'</td>'
          res+='<td style="text-align:center;">'+data[i].zhanbi+'</td></tr>'
        }
        
        res+='</tbody>'
        // res+='<tfoot><td style="text-align:center;border:1px solid #000000">总计</td><td style="text-align:center;border:1px solid #000000">1356</td><td style="text-align:center;border:1px solid #000000">19%</td></tfoot>'
        res+='</table></div></div>'
        return res
  }

}
