import { Component, OnInit } from "@angular/core";
import { Router } from "@angular/router";
import { HttpClient } from "@angular/common/http";
import { EchartsDataService } from "../../echarts-data.service";
import { map } from "rxjs/operators";
declare var echarts: any;
@Component({
  selector: "app-building-type-one",
  templateUrl: "./building-type-one.component.html",
  styleUrls: ["./building-type-one.component.scss"],
})
export class BuildingTypeOneComponent implements OnInit {
  constructor(
    private http: HttpClient,
    private router: Router,
    public echartsData: EchartsDataService
  ) {}

  ngOnInit(): void {
    if (window.matchMedia("(max-width: 1400px)").matches) {
      this.padHw = true;
      //this.padjt=
    } else {
      this.padHw = false;
    }

    window.setTimeout(() => {
      this.getechartsdata();
    });
  }
  ngOnDestroy(): void {
    this.indexBzt.clear();
    this.indexBzt.dispose();
  }
  async getechartsdata() {
    await this.echartsData.getData(
      null,
      `/api/StatisticsAnalysis/BuildingTypes`
    );
    this.initCharts();
  }
  /* 首页饼状图 */
  indexBzt;
  padHw;
  lengthdata = []; //提示数据
  count = 0; //总数
  indexData = []; //所有数据
  tabledata;
  initCharts() {
    if (sessionStorage.getItem("refresh") === "true") {
      sessionStorage.removeItem("refresh");
      location.reload();
    }
    this.tabledata = JSON.parse(JSON.stringify(this.echartsData.allDate));
    // console.log(this.tabledata)
    //console.log(this.echartsData.orid)
    for (var i = 0; i < this.tabledata[0].buildingTypes.length; i++) {
      this.lengthdata.push(this.tabledata[0].buildingTypes[i].buildingTypeName);
      this.count = this.count + this.tabledata[0].buildingTypes[i].count;
      this.indexData.push(this.tabledata[0].buildingTypes[i]);
    }
    //JSON.parse(JSON.stringify(this.indexData).replace(/buildingTypeName/g, 'name'))
    this.indexData = this.indexData.map((v) => {
      return { name: v.buildingTypeName, value: v.count, id: v.buildingTypeId };
    });
    //console.log(this.indexData)
    this.indexBzt = echarts.init(document.getElementById("indexBzt"), "walden");
    let options = {
      title: {
        text: `建筑类型统计（${this.count}家）`,
        left: "center",
        top: "7%",
        textStyle: {
          fontSize: 31,
        },
      },
      tooltip: {
        trigger: "item",
        position: this.echartsData.tableTooltipNoShow2,
        formatter: (params) => {
          this.echartsData.biaogeTishiZhi(params.data);
          return this.echartsData.res;
        },
      },
      legend: {
        orient: "vertical",
        //left:this.padHw?50:0,
        right: this.padHw ? 20 : 250,
        top: 60,
        textStyle: {
          fontSize: 18,
          color: "#000000",
        },
        data: this.lengthdata,
      },
      series: [
        {
          top: this.padHw ? "15%" : "0",
          name: "访问来源",
          type: "pie",
          radius: "60%",
          center: ["50%", "53%"],
          label: {
            show: true,
            fontSize: 18,
            formatter: "{b}{c}家\n{d|({d}%)}",
            rich: {
              d: {
                align: "center",
                fontSize: 18,
              },
            },
          },
          data: this.indexData,
          emphasis: {
            itemStyle: {
              shadowBlur: 10,
              shadowOffsetX: 0,
              shadowColor: "rgba(0, 0, 0, 0.5)",
            },
          },
        },
      ],
    };
    this.indexBzt.on("click", (params) => {
      var index = 0;
      for (var i = 0; i < this.tabledata[0].buildingTypes.length; i++) {
        if (
          this.tabledata[0].buildingTypes[i].buildingTypeName == params.name
        ) {
          if (
            (this.echartsData.level == "0" ||
              this.echartsData.level == "1" ||
              this.echartsData.level == "2") &&
            this.tabledata[0].buildingTypes[i].organizations.length > 0
          ) {

            console.log(111)
            //总队,支队，大队跳转
            this.tabledata[0].buildingTypes[i].organizations.forEach(
              (value, index, array) => {
                if (array[index].organizationId == this.echartsData.orid) {
                  array.splice(index, 1);
                }
                if (array.length > 0) {
                  this.router.navigate(
                    [
                      "/statisticanalysis/buildingType_one/buildingType_two_reverse",
                    ],
                    { queryParams: { level: params.name, id: params.data.id } }
                  );
                } else {
                  this.router.navigate(["/statisticanalysis/CompangInfo"], {
                    queryParams: {
                      name: params.name,
                      type: 1,
                      buildid: params.data.id,
                    },
                  });
                }
              }
            );
          } else {
            console.log(222)
            //中队跳转
            this.router.navigate(["/statisticanalysis/CompangInfo"], {
              queryParams: {
                name: params.name,
                type: 1,
                buildid: params.data.id,
              },
            });
          }
        }
      }
    });
    this.indexBzt.setOption(options);
  }
  tishiData;
  res: string;
  biaogeTishiZhi(datas) {
    for (var a in this.tabledata.buildingTypes) {
      if (this.tabledata.buildingTypes[a].buildingTypeId == datas.id) {
        this.tishiData = this.tabledata.buildingTypes[a].organizations;
      }
    }
    var countall = 0; //总计
    var countbi = 0; //站比
    var allCountbi = 0; //总站比
    for (var i = 0; i < this.tishiData.length; i++) {
      countall += this.tishiData[i].count;
    }
    this.res =
      '<div class="tishi" style=" backgroundColor:rgba(255,255,255,1);width:100%;height:100%;"><div style="padding:10px 0 5px 0"><span style="color:#FFFFFF;font-size:27px;text-align: center;display:block;">' +
      datas.name +
      "</span></div>";
    this.res +=
      '</br><div style="width:300px;height:100%;padding:0 20px 15px 20px"><table style="width:300px;font-size:16px;  color:#FFFFFF;border-collapse:collapse;"cellspacing="0"; >';
    this.res += '<thead style="font-size:18px;"><tr>';
    this.res += '<td style="text-align:center;width:30%;">名称</td>';
    this.res += '<td style="text-align:center;width:30%;">数量</td>';
    this.res += '<td style="text-align:center;width:30%;">总占比</td>';
    this.res += "</tr></thead>";
    this.res += "<tbody>";
    //var res='<div class="tishi" style=" width:100%;height:100%;"><div style="padding:10px 0 5px 0"><span >'+biaotou+'</span></div>'
    for (var i = 0; i < this.tishiData.length; i++) {
      countbi =
        Math.round((this.tishiData[i].count / countall) * 10000) / 100.0;
      allCountbi = allCountbi + countbi;
      this.res += "<tr>";
      this.res +=
        '<td style="text-align:center;">' +
        this.tishiData[i].organizationName +
        "</td>";
      this.res +=
        '<td style="text-align:center;">' + this.tishiData[i].count + "</td>";
      this.res += '<td style="text-align:center;">' + countbi + "%</td></tr>";
    }

    this.res += "</tbody>";
    this.res +=
      '<tfoot style="font-size:18px;"><td style="text-align:center;">总计</td><td style="text-align:center;">' +
      countall +
      '</td><td style="text-align:center;">' +
      allCountbi.toFixed(2) +
      "%</td></tfoot>";
    this.res += "</table></div></div>";
    return this.res;
  }
}
