import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import {EchartsDataService} from '../../echarts-data.service';
declare var echarts: any;
@Component({
  selector: 'app-building-type-two-forward',
  templateUrl: './building-type-two-forward.component.html',
  styleUrls: ['./building-type-two-forward.component.scss']
})
export class BuildingTypeTwoForwardComponent implements OnInit {

  constructor(private router: Router,public data:EchartsDataService) { }
  forward(){
    this.router.navigate(['/statisticanalysis/buildingType_one/buildingType_two_forward'])
  }
  reverse(){
    this.router.navigate(['/statisticanalysis/buildingType_one/buildingType_two_reverse'])
  }
  ngOnInit(): void {
    window.setTimeout(()=>{
      this.tiaoshiPao=this.data.qipao(this.tiaoshiPao,this.zhiNumData,this.zhiNameData)
      this.initCharts()
      this.barEcharts()
    },0)
  }
  ngOnDestroy(): void {
    this.indexBzt.clear()
    this.indexBzt.dispose()
    this.forArr.forEach(item => {
      item.echart.clear()
      item.echart.dispose()
    })
  }
  //返回
  goBack () {
    sessionStorage.setItem('refresh', 'true');
    history.go(-1);
    this.data.statefulInspectionToggle = true
  }
  axisLabel = {
    interval: 0,  
    textStyle:{
      fontSize :16,
      color:'#000000'
    }, 
    formatter:function(value)  
      {    
        var ret = "";//拼接加\n返回的类目项  
        var maxLength = 2;//每项显示文字个数  
        var valLength = value.length;//X轴类目项的文字个数  
        var rowN = Math.ceil(valLength / maxLength); //类目项需要换行的行数  
        if (rowN > 1)//如果类目项的文字大于3,  
        {  
            for (var i = 0; i < rowN; i++) {  
                var temp = "";//每次截取的字符串  
                var start = i * maxLength;//开始截取的位置  
                var end = start + maxLength;//结束截取的位置  
                //这里也可以加一个是否是最后一行的判断，但是不加也没有影响，那就不加吧  
                temp = value.substring(start, end) + "\n";  
                ret += temp; //凭借最终的字符串  
            }  
            return ret;  
        }  
        else {  
            return value;  
        }  
      }  
  }//echarts两个字换行

  topTextlabel = {
    show: true, // 开启显示
    position: 'top', // 在上方显示
    distance: 10, // 距离图形元素的距离。当 position 为字符描述值（如 'top'、'insideRight'）时候有效。
    verticalAlign: 'middle',
    textStyle: { // 数值样式
      color: 'black',
      fontSize: 12
    }
  }//柱状图数值顶部显示

  tableDataZhi = [ {name:"浦东支队",number:"156",zhanbi:"3%"},
                    {name:"黄浦支队",number:"144",zhanbi:"2.8%"},
                    {name:"徐汇支队",number:"133",zhanbi:"2.1%"},
                    {name:"长宁支队",number:"122",zhanbi:"1.6%"},
                    {name:"静安支队",number:"120",zhanbi:"1.3%"},
                    {name:"普陀支队",number:"100",zhanbi:"1.1%"},
                    {name:"虹口支队",number:"95",zhanbi:"1%"},
                    {name:"杨浦支队",number:"90",zhanbi:"0.9%"},
                    {name:"闵行支队",number:"88",zhanbi:"0.8%"},
                    {name:"宝山支队",number:"83",zhanbi:"0.7%"},
                    {name:"徐汇支队",number:"133",zhanbi:"2.1%"},
                    {name:"长宁支队",number:"122",zhanbi:"1.6%"},
                    {name:"嘉定支队",number:"78",zhanbi:"0.6%"},
                    {name:"松江支队",number:"75",zhanbi:"0.5%"},
                    {name:"金山支队",number:"65",zhanbi:"0.4%"},
                    {name:"崇明支队",number:"55",zhanbi:"0.3%"} ]
  tableDataZhong = [ {name:"浦东中队",number:"156",zhanbi:"3%"},
                      {name:"黄浦中队",number:"144",zhanbi:"2.8%"},
                      {name:"徐汇中队",number:"133",zhanbi:"2.1%"},
                      {name:"长宁中队",number:"122",zhanbi:"1.6%"},
                      {name:"静安中队",number:"120",zhanbi:"1.3%"},
                      {name:"普陀中队",number:"100",zhanbi:"1.1%"},
                      {name:"虹口中队",number:"95",zhanbi:"1%"},
                      {name:"杨浦中队",number:"90",zhanbi:"0.9%"},
                      {name:"闵行中队",number:"88",zhanbi:"0.8%"},
                      {name:"宝山中队",number:"83",zhanbi:"0.7%"},
                      {name:"徐汇中队",number:"133",zhanbi:"2.1%"},
                      {name:"长宁中队",number:"122",zhanbi:"1.6%"},
                      {name:"嘉定中队",number:"78",zhanbi:"0.6%"},
                      {name:"松江中队",number:"75",zhanbi:"0.5%"},
                      {name:"金山中队",number:"65",zhanbi:"0.4%"},
                      {name:"崇明中队",number:"55",zhanbi:"0.3%"} ]
  zhiNameData = ["浦东支队","黄浦支队","徐汇支队","长宁支队","静安支队","普陀支队","虹口支队","杨浦支队","闵行支队","宝山支队","嘉定支队","松江支队","金山支队","崇明支队",'青浦支队']
  zhiNumData = [200,190,180,170,160,150,140,130,120,110,100,90,80,70,60,50]
  tiaoshiPao:any
  //气泡提示数据获取
  bianli(){
    var arrshuzu='[';
    for(var i=0;i<this.zhiNumData.length;i++){
      arrshuzu+='{"value":'+this.zhiNumData[i]+',"coord":['+i+','+this.zhiNumData[i]+'],"name":'+'"'+this.zhiNameData[i]+'"'+'},'
    }
    arrshuzu=arrshuzu.substring(0,arrshuzu.length-1)
    arrshuzu+=']'
    this.tiaoshiPao=JSON.parse(arrshuzu)
    //return tishiPao
  }
  pieData = [
      {value: 500, name: '浦东支队'},
      {value: 800, name: '黄浦支队'},
      {value: 900, name: '徐汇支队'},
      {value: 800, name: '长宁支队'},
      {value: 1200, name: '静安支队'},
      {value: 1500, name: '普陀支队'},
      {value: 1400, name: '虹口支队'},
      {value: 600, name: '杨浦支队'},
      {value: 568, name: '闵行支队'},
      {value: 888, name: '宝山支队'},
      {value: 485, name: '嘉定支队'},
      {value: 966, name: '松江支队'},
      {value: 789, name: '金山支队'},
      {value: 500, name: '崇明支队'},
      {value: 600, name: '青浦支队'}
  ]
  buildingTypeName = ['高层','地下','轨道交通','化工生产','储罐类','厂房','古建筑','商市场','医院','学校','宾馆','娱乐场所','餐饮业','影剧院','展览建筑','隧道']
  buildingTypeNum = [200,190,180,170,160,150,140,130,120,110,100,90,80,70,60,50]
  forArr = [{id:'gaoceng',name:'浦东支队',echart:null},
            {id:'dixia',name:'黄浦支队',echart:null},
            {id:'guidao',name:'徐汇支队',echart:null},
            {id:'huagong',name:'长宁支队',echart:null},
            {id:'chuguan',name:'静安支队',echart:null},
            {id:'changfang',name:'普陀支队',echart:null},
            {id:'gujianzhu',name:'虹口支队',echart:null},
            {id:'shichang',name:'杨浦支队',echart:null},
            {id:'yiyuan',name:'闵行支队',echart:null},
            {id:'xuexiao',name:'宝山支队',echart:null},
            {id:'binguan',name:'嘉定支队',echart:null},
            {id:'yule',name:'松江支队',echart:null},
            {id:'canyin',name:'金山支队',echart:null},
            {id:'yingyuan',name:'崇明支队',echart:null},
            {id:'zhanlan',name:'青浦支队',echart:null},
            ]

  /* 顶部饼状图 */
  indexBzt
  initCharts(){
    this.indexBzt = echarts.init(document.getElementById('pie'),'walden');
    let options={
      title: {
        text: '组织机构统计（5500家）',
        left: 'center',
          top: "7%",
          textStyle: {
            fontSize:26
          }
      },
      tooltip: {
        trigger: 'item',
        formatter:  (params)=>{
          return this.data.biaogeTishi(params.name)
        },
        /* backgroundColor:'rgba(255,255,255,1)',//通过设置rgba调节背景颜色与透明度
        borderWidth:'1',
        borderRadius :'0', */
        position: this.data.tableTooltipNoShow2
      },
      legend: {
        orient: 'vertical',
        right: 150,
        top:80,
        textStyle:{
          fontSize:18,
          color:"#000000"
        },
        data:this.zhiNameData
      },
      series: [
        {
          name: '访问来源',
          type: 'pie',
          radius: '70%',
          center: ['50%', '60%'],
          label:{
            show:true,
            fontSize:16,
            formatter:'{b}{c}家\n{d|({d}%)}',
            rich: {
              d: {
                align: 'center',
                fontSize:16
              }
            },
          },
          data: this.pieData,
          emphasis: {
            itemStyle: {
              shadowBlur: 10,
              shadowOffsetX: 0,
              shadowColor: 'rgba(0, 0, 0, 0.5)'
            }
          }
        }
      ]
    };
    this.indexBzt.on('click', (params) => {
      // this.router.navigateByUrl('/statisticanalysis/buildingType_two_forward');
    });
    this.indexBzt.setOption(options);
  }
  //柱状图
  barEcharts(){
    this.forArr.forEach(item=>{
      let _this = this
      item.echart = echarts.init(document.getElementById(item.id),'walden');
      let option = {
        color: ['#3398DB'],
        title: {
          text: item.name+'：总数（1024）',
          left: "center",
          top: "0",
          //bottom: '80',
          textStyle: {
            fontSize: 23
          }
        },
        xAxis: {
            type: 'category',
            data: this.buildingTypeName,
            axisLabel: this.axisLabel
        },
        yAxis: {
            type: 'value',
            axisLabel:{
              //this.axisLabel,
              textStyle:{
                fontSize :16,
                color:'#000000'
              }
              
            }
        },
        tooltip: {
          trigger: 'item',
          formatter:  (params)=>{
            return this.data.tableTooltip(this.tableDataZhong,params.name)
          }
        },
        series: [{
            data: this.buildingTypeNum,
            type: 'bar',
            markPoint: {
              data: this.tiaoshiPao
          },
            backgroundStyle: {
                color: 'rgba(220, 220, 220, 0.8)'
            },
            barWidth :'28',
            //label: this.topTextlabel
        }]
      };
      item.echart.setOption(option);
      item.echart.on('click', (params) => {
        this.router.navigate(['/statisticanalysis/buildingType_one/buildingType_three_details'],{queryParams:{'organizationName':item.name,'buildingTypeName':params.name}})
      });
    })
    
  }
  //提示框表格
  tableTooltip(dataArr,title:string){
    let data = dataArr
    var res = '<div class="tishi" style=" backgroundColor:rgba(255,255,255,1);width:100%;height:100%;"><div style="padding:10px 0 5px 0"><span style="color:#FFFFFF;font-size:27px;text-align: center;display:block;">'+title+'</span></div>'
       res+='</br><div style="width:300px;height:100%;padding:0 20px 15px 20px"><table style="width:300px;font-size:16px;  color:#FFFFFF;border-collapse:collapse;"cellspacing="0"; >';
       res+='<thead style="font-size:18px;"><tr>';
       res+='<td style="text-align:center;width:30%;">名称</td>';
       res+='<td style="text-align:center;width:30%;">数量</td>'
       res+='<td style="text-align:center;width:30%;">总占比</td>'
       res+='</tr></thead>'
       res+='<tbody>';
       //var res='<div class="tishi" style=" width:100%;height:100%;"><div style="padding:10px 0 5px 0"><span >'+biaotou+'</span></div>'
       for(var i=0;i<this.tableDataZhi.length;i++){
         res+='<tr>'
         res+='<td style="text-align:center;">'+this.tableDataZhi[i].name+'</td>'
         res+='<td style="text-align:center;">'+this.tableDataZhi[i].number+'</td>'
         res+='<td style="text-align:center;">'+this.tableDataZhi[i].zhanbi+'</td></tr>'
       }
       
       res+='</tbody>'
       res+='<tfoot style="font-size:18px;"><td style="text-align:center;">总计</td><td style="text-align:center;">1356</td><td style="text-align:center;">19%</td></tfoot>'
       res+='</table></div></div>'
       return res
  }
}
