import { Component, OnInit, Inject } from '@angular/core';
import {MatTreeFlatDataSource, MatTreeFlattener} from '@angular/material/tree';
import {FlatTreeControl} from '@angular/cdk/tree';
import { HttpClient } from '@angular/common/http';
import {MatDialog, MatDialogRef, MAT_DIALOG_DATA} from '@angular/material/dialog';
import {FormControl} from '@angular/forms';
import { MatSnackBar } from '@angular/material/snack-bar';
@Component({
    selector: 'selectoriginalcopy',
    templateUrl: './selectoriginalcopy.component.html',
    styleUrls: ['./material-bank.component.scss']
  })
  export class SelectOriginalCopy {
    myControl = new FormControl();
    constructor(private http: HttpClient,public dialogRef: MatDialogRef<SelectOriginalCopy>,@Inject(MAT_DIALOG_DATA) public data) {}
    matlibrary = this.data.allMaterialBank//所有素材库
    selectedmatlibraryid = ""//当前下拉框选中的素材库id
    sourceMaterial:any; //指定素材库对应所有原件
    atpresentSourceMaterial:any//当前选择原件素材库对应所有原件
    aaa = this.data.allMaterialBank[0].id//默认显示第一个素材库
    ngOnInit(): void {
      this.getatpresentSourceMaterial ()//初始化时先获取一下当前素材库对应所有原件，然后在获取指定素材库原件时进行筛选对比
      let data = {
        libraryId:this.data.allMaterialBank[0].id
      }
      this.http.get('/api/Assets',{
        params:data
      }).subscribe((data : any)=>{
        data.forEach(item => {
          this.atpresentSourceMaterial.forEach(n=>{
            if(n.id == item.id){
              item.isselected = true
            }
          })
        });
        this.sourceMaterial = data
      })
      
    }
    onNoClick(): void {
      this.dialogRef.close();
    }
    
    //获得指定素材库所有原件
    getSourceMaterial () {
      let data = {
        libraryId:this.selectedmatlibraryid
      }
      this.http.get('/api/Assets',{
        params:data
      }).subscribe((data : any)=>{
        data.forEach(item => {
          this.atpresentSourceMaterial.forEach(n=>{
            if(n.id == item.id){
              item.isselected = true
            }
          })
        });
        this.sourceMaterial = data
      })
    }
    //获得当前素材库所有原件
    getatpresentSourceMaterial (){
      let data = {
        libraryId:this.data.material.id
      }
      this.http.get('/api/Assets',{
        params:data
      }).subscribe(data=>{
        this.atpresentSourceMaterial = data
      })
    }
    selectmatlibrart(item){//点击下拉框中的一项
      this.selectedmatlibraryid = item.id
      this.getSourceMaterial ()
    }
    selectedimg = []//需要提交的原件id数组
    clickimg(item){//点击选择原件的多张图片
      if(!item.isselected){
        if(item.istrue){//如果图片已经被选中，此时点击
          item.istrue = false
          this.selectedimg.forEach((n,index) => {
            if(n == item.id){//将此id从数组中移除
              this.selectedimg.splice(index,1)
            }
          });
        }else{//如果图片还没有被选中
          item.istrue = true
          this.selectedimg.push(item.id)//将选中图片id存入数组
        }
      }

    }
    onSubmit(value){
      this.http.post("/api/Assets/Select",{
        assetLibraryId:this.data.material.id ,
        assetIds: this.selectedimg
      }).subscribe(data=>{
        this.dialogRef.close('ooo');
      })
    }
  }