import { Component, OnInit, Inject } from '@angular/core';
import {MatTreeFlatDataSource, MatTreeFlattener} from '@angular/material/tree';
import {FlatTreeControl} from '@angular/cdk/tree';
import { HttpClient } from '@angular/common/http';
import {MatDialog, MatDialogRef, MAT_DIALOG_DATA} from '@angular/material/dialog';
import {FormControl} from '@angular/forms';
import { MatSnackBar } from '@angular/material/snack-bar';


@Component({
    selector: 'editgroup',
    templateUrl: './editgroup.component.html',
    styleUrls: ['./unit-information.component.scss']
  })
  export class EditGroup {
    myControl = new FormControl();

    groupname = this.data.item.name //分组名
    grouptype = String(this.data.item.type) //分组类型
    groupaddMode = String(this.data.item.addMode) //数据行为

    templatestatus = "0"//创建模板时的默认状态
    constructor(private http: HttpClient,public dialogRef: MatDialogRef<EditGroup>,@Inject(MAT_DIALOG_DATA) public data) {}

    ngOnInit(): void {

    }

    onNoClick(): void {
      this.dialogRef.close();
    }

    onSubmit(value){
      this.http.put(`/api/BasicGroups/${this.data.item.id}`,{
        id: this.data.item.id,
        name: value.groupname,
        type: Number(value.propertyType),
        addMode:Number(value.databehavior),
        isOptional: this.data.item.isOptional,
        order: this.data.item.order,
        enabled: this.data.item.enabled,
        propertyInfos:this.data.item.propertyInfos,
        basicCategoryId: this.data.item.basicCategoryId
      }).subscribe(data=>{
          this.dialogRef.close('ooo');
      })
    }

  }